/// <reference types="react" />
import { InputProps } from '../Input';
/**
 * 控制输入框属性
 */
export interface ControlInputProps extends Omit<InputProps, 'onChange' | 'value' | 'onAbort'> {
    /**
     * 输入框变化回调函数
     * @param value - 输入框的值
     */
    onChange?: (value: string) => void;
    /**
     * 输入框值变化前回调函数
     * @param value - 输入框的值
     */
    onValueChanging?: (value: string) => void;
    /**
     * 输入框的值
     */
    value?: string;
    /**
     * 输入框变化结束回调函数
     * @param value - 输入框的值
     */
    onChangeEnd?: (value: string) => void;
}
export declare const ControlInput: import("react").NamedExoticComponent<ControlInputProps>;
