import { CSSProperties, ReactNode } from 'react';
export interface EditNodePreviewProps {
    /**
     * 标题
     */
    title?: string;
    /**
     * 额外的 ReactNode
     */
    extra?: ReactNode;
    /**
     * 子元素 ReactNode
     */
    children?: ReactNode;
    /**
     * 是否激活状态
     */
    active?: boolean;
    /**
     * 自定义类名
     */
    className?: string;
    /**
     * 自定义样式
     */
    style?: CSSProperties;
    /**
     * 折叠的键数组
     * @default []
     */
    collapsedKeys?: string[];
    /**
     * 折叠键数组变化时的回调函数
     */
    onCollapsedKeysChange?: (collapsedKeys: string[]) => void;
    /**
     * 标题变化时的回调函数
     */
    onTitleChange?: (title: string) => void;
}
declare const Preview: import("react").NamedExoticComponent<EditNodePreviewProps>;
interface EditNodeProps extends EditNodePreviewProps {
    /**
     * 节点的 id
     */
    id: string;
}
interface IEditNode {
    (props: EditNodeProps): ReactNode;
    Preview: typeof Preview;
}
declare const EditNode: IEditNode;
export default EditNode;
