import { shallow } from 'zustand/shallow';
import { createWithEqualityFn } from 'zustand/traditional';
import { createContext, optionalDevtools } from 'zustand-utils';
import { DocWithHistoryManager } from "../utils/yjs";
import { createStore } from "./actions";
export var createFlowEditorStore = function createFlowEditorStore() {
  var showDevtools = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
  var doc = new DocWithHistoryManager();
  return createWithEqualityFn()(optionalDevtools(showDevtools)(createStore(doc), {
    name: 'FLOW_EDITOR'
  }), shallow);
};
var _createContext = createContext(),
  Provider = _createContext.Provider,
  useStore = _createContext.useStore,
  useStoreApi = _createContext.useStoreApi;
export { Provider, useStore, useStoreApi };
export * from "./selectors";