/// <reference types="react" />
import { Node } from 'reactflow';
import { FlowEditorStore } from './actions';
export declare const flowEditorSelectors: {
    nodeList: (s: FlowEditorStore) => Node[];
    edgeList: (s: FlowEditorStore) => ({
        selected: boolean;
        id: string;
        type?: string | undefined;
        source: string;
        target: string;
        sourceHandle?: string | null | undefined;
        targetHandle?: string | null | undefined;
        style?: import("react").CSSProperties | undefined;
        animated?: boolean | undefined;
        hidden?: boolean | undefined;
        deletable?: boolean | undefined;
        data?: any;
        className?: string | undefined;
        sourceNode?: Node | undefined;
        targetNode?: Node | undefined;
        markerStart?: import("reactflow").EdgeMarkerType | undefined;
        markerEnd?: import("reactflow").EdgeMarkerType | undefined;
        zIndex?: number | undefined;
        ariaLabel?: string | undefined;
        interactionWidth?: number | undefined;
        focusable?: boolean | undefined;
        updatable?: import("reactflow").EdgeUpdatable | undefined;
        label?: import("react").ReactNode;
        labelStyle?: import("react").CSSProperties | undefined;
        labelShowBg?: boolean | undefined;
        labelBgStyle?: import("react").CSSProperties | undefined;
        labelBgPadding?: [number, number] | undefined;
        labelBgBorderRadius?: number | undefined;
    } | {
        selected: boolean;
        id: string;
        type: "smoothstep";
        source: string;
        target: string;
        sourceHandle?: string | null | undefined;
        targetHandle?: string | null | undefined;
        style?: import("react").CSSProperties | undefined;
        animated?: boolean | undefined;
        hidden?: boolean | undefined;
        deletable?: boolean | undefined;
        data?: any;
        className?: string | undefined;
        sourceNode?: Node | undefined;
        targetNode?: Node | undefined;
        markerStart?: import("reactflow").EdgeMarkerType | undefined;
        markerEnd?: import("reactflow").EdgeMarkerType | undefined;
        zIndex?: number | undefined;
        ariaLabel?: string | undefined;
        interactionWidth?: number | undefined;
        focusable?: boolean | undefined;
        updatable?: import("reactflow").EdgeUpdatable | undefined;
        label?: import("react").ReactNode;
        labelStyle?: import("react").CSSProperties | undefined;
        labelShowBg?: boolean | undefined;
        labelBgStyle?: import("react").CSSProperties | undefined;
        labelBgPadding?: [number, number] | undefined;
        labelBgBorderRadius?: number | undefined;
        pathOptions?: import("reactflow").SmoothStepPathOptions | undefined;
    } | {
        selected: boolean;
        id: string;
        type: "default";
        source: string;
        target: string;
        sourceHandle?: string | null | undefined;
        targetHandle?: string | null | undefined;
        style?: import("react").CSSProperties | undefined;
        animated?: boolean | undefined;
        hidden?: boolean | undefined;
        deletable?: boolean | undefined;
        data?: any;
        className?: string | undefined;
        sourceNode?: Node | undefined;
        targetNode?: Node | undefined;
        markerStart?: import("reactflow").EdgeMarkerType | undefined;
        markerEnd?: import("reactflow").EdgeMarkerType | undefined;
        zIndex?: number | undefined;
        ariaLabel?: string | undefined;
        interactionWidth?: number | undefined;
        focusable?: boolean | undefined;
        updatable?: import("reactflow").EdgeUpdatable | undefined;
        label?: import("react").ReactNode;
        labelStyle?: import("react").CSSProperties | undefined;
        labelShowBg?: boolean | undefined;
        labelBgStyle?: import("react").CSSProperties | undefined;
        labelBgPadding?: [number, number] | undefined;
        labelBgBorderRadius?: number | undefined;
        pathOptions?: import("reactflow").BezierPathOptions | undefined;
    })[];
};
