import { Doc, UndoManager } from 'yjs';
import { DocOpts } from 'yjs/dist/src/utils/Doc';
interface UserActionParams {
    type: string;
    name: string;
    timestamp: number;
}
export declare class DocWithHistoryManager<T = object> extends Doc {
    private _internalHistoryKey;
    constructor(params?: DocOpts);
    undoManager: UndoManager;
    updateHistoryData: (value: Partial<T>) => void;
    recordHistoryData: (value: Partial<T>, userAction: UserActionParams) => void;
    getHistoryMap: () => import("yjs").Map<unknown>;
    getHistoryJSON: () => T;
    redo: () => import("yjs/dist/src/internals").StackItem | null;
    undo: () => import("yjs/dist/src/internals").StackItem | null;
}
export {};
