import { Node } from 'reactflow';
export declare enum SelectType {
    SELECT = "SELECT",
    SUB_SELECT = "SUB_SELECT",
    DANGER = "DANGER",
    SUB_DANGER = "SUB_DANGER",
    WARNING = "WARNING",
    SUB_WARNING = "SUB_WARNING",
    DEFAULT = "DEFAULT"
}
export interface InitialNode extends Node {
    width?: number;
    height?: number;
}
export interface NodeMapItem<T = any, U extends string | undefined = string | undefined> {
    id: string;
    key?: string;
    left?: string[];
    right?: string[];
    skip?: boolean;
    title?: string;
    group?: boolean;
    des?: string;
    width?: number | null;
    height?: number | null;
    danger?: boolean;
    dangerCount?: number;
    type?: U;
    className?: string;
    select?: SelectType;
    isGroup?: boolean;
    childrenNeedFold?: boolean;
    haveAlert?: boolean;
    mainDanger?: boolean;
    qualityScore?: string;
    subDanger?: boolean;
    logo?: string;
    data: T;
    nodeType?: string;
    zoom?: number;
    label?: string;
    position?: {
        x: number;
        y: number;
    };
}
export interface LayoutOptions {
    width?: number | undefined;
    height?: number | undefined;
    compound?: boolean | undefined;
    rankdir?: string | undefined;
    align?: string | undefined;
    nodesep?: number | undefined;
    edgesep?: number | undefined;
    ranksep?: number | undefined;
    marginx?: number | undefined;
    marginy?: number | undefined;
    acyclicer?: string | undefined;
    ranker?: string | undefined;
}
export type NodeMapping = Record<string, NodeMapItem>;
export declare const NODE_SELECT = "nodeSelected";
export declare const NODE_SUB_SELECT = "nodeSubSelected";
export declare const NODE_DANGER = "nodeDanger";
export declare const NODE_SUB_DANGER = "nodeSubDanger";
export declare const NODE_WARNING = "nodeWarning";
export declare const NODE_SUB_WARNING = "nodeSubWarning";
export declare const EDGE_SELECT = "edgeSelected";
export declare const EDGE_SUB_SELECT = "edgeSubSelected";
export declare const EDGE_DANGER = "edgeDanger";
export declare const EDGE_SUB_DANGER = "edgeSubDanger";
export declare const EDGE_WARNING = "edgeWarning";
export declare const EDGE_SUB_WARNING = "edgeSubWarning";
export declare const INIT_NODE = "initialNode";
export declare const NODE_WRAP = "nodeWrap";
